Attribute VB_Name = "Module1"
Option Explicit

Private Declare Sub CopyMemoryByteToStr Lib "kernel32" Alias "RtlMoveMemory" (ByVal lpvDest As String, lpvSource As Any, ByVal cbCopy As Long)

''' WinApi function that maps a UTF-16 (wide character) string to a new character string
Private Declare Function WideCharToMultiByte Lib "kernel32" ( _
    ByVal CodePage As Long, _
    ByVal dwFlags As Long, _
    ByVal lpWideCharStr As Long, _
    ByVal cchWideChar As Long, _
    ByVal lpMultiByteStr As Long, _
    ByVal cbMultiByte As Long, _
    ByVal lpDefaultChar As Long, _
    ByVal lpUsedDefaultChar As Long) As Long

' CodePage constant for UTF-8
Private Const CP_UTF8 = 65001

''' Return byte array with VBA "Unicode" string encoded in UTF-8
Public Function Utf8BytesFromString(strInput As String) As String
    Dim nBytes As Long
    Dim abBuffer() As Byte
    Dim MyVar As String
    
    ' Get length in bytes *including* terminating null
    nBytes = WideCharToMultiByte(CP_UTF8, 0&, ByVal StrPtr(strInput), -1, vbNull, 0&, 0&, 0&)
    ' We don't want the terminating null in our byte array, so ask for `nBytes-1` bytes
    ReDim abBuffer(nBytes - 2)  ' NB ReDim with one less byte than you need
    nBytes = WideCharToMultiByte(CP_UTF8, 0&, ByVal StrPtr(strInput), -1, ByVal VarPtr(abBuffer(0)), nBytes - 1, 0&, 0&)
    
    MyVar = String(UBound(abBuffer) + 1, " ") ' marger la variable de travail.
    CopyMemoryByteToStr ByVal MyVar, abBuffer(0), UBound(abBuffer) + 1

    'abBuffer byte2string
    Utf8BytesFromString = MyVar
        
End Function

Sub Main()

Dim Text_Inp As String
Dim fh1, fh2 As Integer
Dim fname As String

fh1 = FreeFile
fname = Command$

Open fname For Binary As fh1
Text_Inp = Input(LOF(fh1), fh1)
Close #fh1


If Mid(Text_Inp, 1, 1) <> Chr$(239) And Mid(Text_Inp, 2, 1) <> Chr$(187) Then

    If Mid(Text_Inp, 1, 1) <> Chr$(255) And Mid(Text_Inp, 2, 1) <> Chr$(254) Then
    Text_Inp = Chr$(239) + Chr$(187) + Chr$(191) + Utf8BytesFromString(Text_Inp)

    fh2 = FreeFile
    'MsgBox App.Path & "\utf8\" & CutName(fname), vbCritical
    Open App.Path & "\utf8\" & CutName(fname) For Binary As fh2
    Put #fh2, 1, Text_Inp
    Close #fh2
    End If
End If
Reset


End Sub

Private Function CutName(name As String) As String
Dim cnt As Integer
For cnt = Len(name) To 1 Step -1
If Mid(name, cnt, 1) = "\" Or Mid(name, cnt, 1) = "/" Then Exit For
Next
If cnt = 0 Then cnt = 1
CutName = Mid(name, cnt)
End Function
